




clear;
close all;

addpath('D:\COMPUTATION\MATLAB\PI');

% READ AND TRIM B1MAPS
load B1MAPS;

mask = double( sum(abs(B1MAPS),3) > 0 );
ind = find( mask );
[ indx indy ] = ind2sub( size(mask),ind );

xmin = min(indx); xmax = max(indx);
ymin = min(indy); ymax = max(indy);

B1MAPS = B1MAPS( xmin:xmax , ymin:ymax , : );


[ nx ny ncoils ] = size(B1MAPS);
nx0 = nx;
ny0 = ny;

B1MAPS = reshape( B1MAPS,nx,ny,1,ncoils );


% LOSS MATRIX
LOSS = reshape( read_ddata( '../fields/LOSS_N_2500.dat',-1 ),ncoils,2*ncoils );
LOSS = LOSS( :,1:2:end ) + 1j*LOSS( :,2:2:end );

% scale LOSS for num stability (does not change the GFAC result)
LOSS = LOSS / max(abs(LOSS(:)));

US_fac_x = [ 4 ];
US_fac_y = [ 5 ];

New_nx = ceil( nx ./ US_fac_x ) .* US_fac_x;  % make sure the new acc dim is divisible by US_fac
New_ny = ceil( ny ./ US_fac_y ) .* US_fac_y;

figure;
Nimg1 = ceil( sqrt( size(US_fac_x,2) ) );

Nimg2 = Nimg1;
if (Nimg2-1)*Nimg1 >= size(US_fac_x,2)
    Nimg2 = Nimg1 - 1;
end


for ii = 1 : size(US_fac_x,2)
    
    fprintf('SENSE %dx%d\n',US_fac_x(ii),US_fac_y(ii));
    
    if New_ny(ii) ~= ny0 || New_nx(ii) ~= nx0
        XX = linspace( 0,1,nx0 );
        YY = linspace( 0,1,ny0 );
        ZZ = linspace( 0,1,ncoils );
        
        XX2 = linspace( 0,1,New_nx(ii) );
        YY2 = linspace( 0,1,New_ny(ii) );
        ZZ2 = linspace( 0,1,ncoils );
        
        [ XXX2 YYY2 ZZZ2 ] = ndgrid( XX2 , YY2 , ZZ2 );

        B1MAPS2 = reshape( interpn( XX , YY , ZZ , squeeze(B1MAPS) , XXX2 , YYY2 , ZZZ2 ) , New_nx(ii) , New_ny(ii) , 1, ncoils );
    else
        B1MAPS2 = B1MAPS;
    end

    [nx ny nz ncoils] = size(B1MAPS2);
    US = zeros(nx,ny);
    US( 1:US_fac_x(ii):end , 1:US_fac_y(ii):end ) = 1;
    IMG = ones( nx,ny,1,ncoils );
    
    [IMG_rec GFAC] = pi_sense( IMG , B1MAPS2 , LOSS , US , 1);

    eval( sprintf( 'save GFAC_%dx%d.mat GFAC;',US_fac_x(ii),US_fac_y(ii) ) );
    
    subplot( Nimg1,Nimg2,ii ); 
    imagesc(GFAC); axis image off; colorbar; 
    drawnow;

end



























